#include "Application.h"
#include <exception>
#include <iostream>

void Application::apply_deffer_state_change()
{
	if (this->ptr_next_state_) {
		this->ptr_curr_state_ = std::move(this->ptr_next_state_);
		this->ptr_next_state_.reset();
	}
}

int Application::run()
{
	try {
		while (this->ptr_curr_state_ && this->ptr_curr_state_->do_step()) {
			(*this).apply_deffer_state_change();
		}
	} catch (std::exception& e) {
		std::cout << e.what() << '\n';
		return 1;
	} catch (...) {
		std::cout << "Unknown error" << '\n';
		return 2;
	}
	return 0;
}
