#pragma once

#include "../IStateManager.h"
#include "../IState.h"
#include <memory>
#include "../SelectState/SelectState.h"
#include "../ExitState/ExitState.h"

#define WIGHT 1000
#define HEIGHT 600
#define TITLE "Menu"

class Application : public IStateManager {
private:
	std::unique_ptr<IState> ptr_next_state_ = nullptr;
	std::unique_ptr<IState> ptr_curr_state_ = std::make_unique<SelectState>(*this, sf::VideoMode{WIGHT, HEIGHT}, TITLE);;
	void set_next_state(std::unique_ptr<IState>&& state) override { this->ptr_next_state_ = std::move(state); };
	void apply_deffer_state_change();
public:
	int run();
	Application() = default;
	//Application(std::unique_ptr<IState> state) : ptr_curr_state_(std::move(state)) {};
};