#include"Button.h"
#include <functional>
#include <SFML/Graphics.hpp>
#include <iostream>
#include "MyFont.h"

void Button::set(const sf::Vector2f& pos, const sf::Vector2f& size, const std::string& text, const size_t font_size, std::unique_ptr<ISelectCommand> command) {
	(*this).shape_.setPosition(pos);
	(*this).shape_.setSize(size);
	(*this).shape_.setFillColor(sf::Color::Green);
	(*this).shape_.setOutlineThickness(10);
	(*this).shape_.setOutlineColor(sf::Color::White);
	(*this).command_ = std::move(command);

	(*this).text_.setFont(MyFont::Instance().getFont());
	(*this).text_.setString(text);
	(*this).text_.setCharacterSize(font_size);
	(*this).text_.setFillColor(sf::Color::White);
	(*this).text_.setPosition(pos.x + 80, pos.y + 10);
}

void Button::draw_into(sf::RenderWindow& window) const {
	window.draw((*this).shape_);
	window.draw((*this).text_);
}

bool Button::is_position_in(const sf::Vector2f pos) {
	if (shape_.getGlobalBounds().contains(pos)) {
		return 1;
	}
}

void Button::push()
{
	(*this).command_->execute();
}
