#pragma once 

#include <SFML/Graphics.hpp> 
#include <SFML/Window.hpp> 
#include <SFML/System.hpp>
#include "../IDrawable.h"
#include "Command/ISelectCommand.h"
#include "MyFont.h"

class Button : public IDrawable {
private:
	sf::Text text_;
	sf::RectangleShape shape_;
	sf::Font font_;
	bool is_selected_ = false;
	std::unique_ptr<ISelectCommand> command_;
public:
	Button() = default;
	void set(const sf::Vector2f& pos, const sf::Vector2f& size, const std::string& text, const size_t font_size, std::unique_ptr<ISelectCommand> command);
	void select() { (*this).shape_.setFillColor(sf::Color::Yellow); }
	void unselect() { (*this).shape_.setFillColor(sf::Color::Green); }
	bool is_position_in(const sf::Vector2f pos);
	void push();
	void draw_into(sf::RenderWindow& window) const override;
};
