#pragma once
#include <SFML/Graphics.hpp> 
#include <SFML/Window.hpp> 
#include <SFML/System.hpp>

class IWindowKeeper {
protected:
	sf::RenderWindow m_window;
	void virtual event_handler() = 0;
	void virtual update() = 0;
	void virtual render() = 0;
	virtual ~IWindowKeeper() = default;
	IWindowKeeper(IWindowKeeper&) = delete;
	IWindowKeeper& operator=(IWindowKeeper&) = delete;
public:
	IWindowKeeper(sf::VideoMode vm, std::string title) { (*this).m_window.create(vm, title); };
};