#include"Menu.h"
#include"../Button/Command/ExitCommand.h"

Menu::Menu(IStateManager& manager) {
	(*this).buttons[0] = Button();
	(*this).buttons[0].set(sf::Vector2f{ 400, 250 }, sf::Vector2f{ 200, 50 }, std::string("EASY"), size_t(24), std::make_unique<ISelectCommand>(ISelectCommand{}));//, ISelectCommand{});
	(*this).buttons[1] = Button();	
	(*this).buttons[1].set(sf::Vector2f{ 400, 350 }, sf::Vector2f{ 200, 50 }, std::string("EXIT"), size_t(24), std::make_unique<ExitCommand>(ExitCommand(manager)));// , ISelectCommand{});
	(*this).buttons[2] = Button();
	(*this).buttons[2].set(sf::Vector2f{ 400, 150 }, sf::Vector2f{ 200, 50 }, std::string("MEDIUM"), size_t(24), std::make_unique<ISelectCommand>(ISelectCommand{}));
	(*this).buttons[3] = Button();
	(*this).buttons[3].set(sf::Vector2f{ 400, 50 }, sf::Vector2f{ 200, 50 }, std::string("HARD"), size_t(24), std::make_unique<ISelectCommand>(ISelectCommand{}));
}

void Menu::draw_into(sf::RenderWindow& window) const {
	for (int i = 0; i < 4; ++i) {
		buttons[i].draw_into(window);
	}
}

void Menu::process_mouse(sf::Vector2f pos, bool is_pressed) {
	for (auto& button : buttons) {
		if (button.is_position_in(pos)) {
			button.select();
			if (is_pressed) button.push();
		}
		else {
			button.unselect();
		}
	}
}