﻿#include "SelectState.h"
#include "../ExitState/ExitState.h"

#include <SFML/Graphics.hpp> 
#include <SFML/Window.hpp> 
#include <SFML/System.hpp>

SelectState::SelectState(IStateManager& manager, sf::VideoMode vm, std::string title) : IState(manager), IWindowKeeper(vm, title)
{
}

bool SelectState::do_step() {
	(*this).m_window.clear();
	(*this).menu_.get()->draw_into((*this).m_window);
	(*this).m_window.display();
	(*this).event_handler();
	(*this).update();
	(*this).render();
	return 1;
}
/*
void SelectState::event_handler() {
	sf::Event event;
	while (m_window.pollEvent(event))
		switch (event.type) {
		case sf::Event::Closed:
			m_window.close();
			break;
		case sf::Event::MouseEntered:
			std::cout << "Mouse entered window!\n";
			break;
		case sf::Event::MouseLeft:
			std::cout << "Mouse left window!\n";
			break;
		case sf::Event::MouseMoved:
			std::cout << "New position of mouse: " <<
				event.mouseMove.x << ' ' << event.mouseMove.y << '\n';
		case sf::Event::MouseButtonPressed: // т.е. зажата ли какая-то кнопка?
			if (event.mouseButton.button == sf::Mouse::Button::Left)
				std::cout << "Left button is pressed!\nMouse position: " <<
				event.mouseButton.x << ' ' << event.mouseButton.y << '\n';
			break;
		case sf::Event::MouseButtonReleased: // т.е. отжата ли какая-то кнопка?
			if (event.mouseButton.button == sf::Mouse::Button::Left)
				std::cout << "Left button is pressed!\nMouse position: " <<
				event.mouseButton.x << ' ' << event.mouseButton.y << '\n';
			break;
		case sf::Event::MouseWheelScrolled:
			std::cout << "Delta: " << event.mouseWheelScroll.delta << '\n' <<
				"Which wheel: " << event.mouseWheelScroll.wheel << '\n' <<
				"Position: " << event.mouseWheelScroll.x << ' ' <<
				event.mouseWheelScroll.y << '\n';
		}
}*/


void SelectState::event_handler() {
		sf::Event event;
		while ((*this).m_window.pollEvent(event)) {
			switch (event.type)
			{
			case(sf::Event::Closed):
				(*this).state_manager_.set_next_state(std::make_unique<ExitState>((*this).state_manager_));
				break;
			case sf::Event::MouseMoved:
				(*this).menu_.get()->process_mouse((*this).m_window.mapPixelToCoords(sf::Mouse::getPosition((*this).m_window)), sf::Mouse::isButtonPressed(sf::Mouse::Left));
				break;
			case sf::Event::MouseEntered:
				std::cout << "Mouse entered window!\n";
				break;

			}
	}

}
